
function sigma(t)
  return 0.5 * (1+ math.tanh(t/2))
end


local score = 0
local x = 20
local y = 200
local dx = 0
local dy = 0
local vx = 0
local vy = 0

local enemies = {}
local bullets = {}
local nextspawn = 3
local nextp = 0.1
local time = 0

local gameover = false

local particles = {}

function love.keypressed(key)
  if key == 'up' then
    dy = dy - 1
  elseif key == 'down' then
    dy = dy + 1
  elseif key == 'left' then
    dx = dx - 1
  elseif key == 'right' then
    dx = dx + 1
  elseif key == 'x' then
    bullets[#bullets+1] = {x-80, y}
  end
end


function love.keyreleased(key)
  if key == 'up' then
    dy = dy + 1
  elseif key == 'down' then
    dy = dy - 1
  elseif key == 'left' then
    dx = dx + 1
  elseif key == 'right' then
    dx = dx - 1
  end
end


function love.update(dt)
  if not gameover then
    vx = vx + 3000 * dt * dx
    vy = vy + 3000 * dt * dy
    local scale = 500
    if vx > 500 then vx = 500 end
    if vx < -500 then vx = -500 end
    if vy > 500 then vy = 500 end
    if vy < -500 then vy = -500 end
    if dx == 0 then
      if vx > 0 then
        vx = vx - dt * scale
        if vx < 0 then
          vx = 0
        end
      else
        vx = vx + dt * scale
        if vx > 0 then
          vx = 0
        end
      end
    end

    if dy == 0 then
      if vy > 0 then
        vy = vy - dt * scale
        if vy < 0 then
          vy = 0
        end
      else
        vy = vy + dt * scale
        if vy > 0 then
          vy = 0
        end
      end
    end
    y = y + vy * dt
    x = x + vx * dt

    if x < 0 then
      x = 0
      vx = -vx
    end

    if x > 800 then
      x = 800 
      vx = -vx
    end

    if y < 0 then
      y = 0
      vy = -vy
    end

    if y > 600 then
      y = 600 
      vy = -vy
    end

    local bd = {}
    for i, b in ipairs(bullets) do
      b[1] = b[1] + dt * 5000

      for j = 1, math.floor(500 * dt) do
        particles[#particles+1] = {b[1] + math.random()*(b[1] - dt * 5000), b[2], math.random() * 50 - 500 ,math.random() * 200 - 100}
      end

      if b[1] > 800 then
        bd[#bd+1] = i
      end
    end


    time = time + dt

    if nextspawn <= time then
      enemies[#enemies+1] = {850, love.math.random(600), love.math.random(0, 10), love.math.random(-3,3), love.math.random(1, 3), love.math.random(30, 50), 4 + love.math.random(4)}
      nextspawn = nextspawn + (1-sigma(time / 30)) * 5
    end

    local ed = {}
    for i, e in ipairs(enemies) do
      e[1] = e[1] - dt * 200 * e[5]
      e[3] = e[3] + e[4] * dt

      if e[1] < -100 then
        ed[i] = i
      end

      for bi, b in ipairs(bullets)  do
        if not b[3] then
          if b[1] > e[1] - e[6] - 3000 * dt and b[1] < e[1] + e[6] + 100 and b[2] > e[2] - e[6] and b[2] < e[2] + e[6] then
            if not e[8] then
              score = score + 100
              for p = 1, 400 do
                local a = math.random()
                local d = math.random()
                particles[#particles+1] = {e[1] + math.sin(a * 2 * math.pi) * d * e[6], e[2] + math.cos(a * 2 * math.pi) * d * e[6], math.sin(a*2*math.pi)*math.random()*400-200*e[5], math.cos(a*2*math.pi)*math.random()*400}
              end
            end
            e[8] = true
            b[3] = true
            ed[i] = i
            bd[bi] = bi
          end
        end
      end

      local ddx = e[1] - x
      local ddy = e[2] - y
      if math.sqrt(ddx*ddx + ddy*ddy) < e[6] + 10 then
        gameover = true
      end

    end

    for i in pairs(bd) do
      table.remove(bullets, bd[i])
    end

    for i in pairs(ed) do
      table.remove(enemies, ed[i])
    end

    score = score + dt

    --[[
    local dp = {}
    for i, p in ipairs(particles) do
      p[1] = p[1] + dt * p[3]
      p[2] = p[2] + dt * p[4]
      if p[2] > 600 or p[2] < 0 or p[1] < 0 or p[1] > 800 then
        dp[i] = i
      end
    end
    --]]
    for i = #particles, 1, -1 do
      local p = particles[i]
      p[1] = p[1] + dt * p[3]
      p[2] = p[2] + dt * p[4]
      if p[2] > 600 or p[2] < 0 or p[1] < 0 or p[1] > 800 then
        particles[i] = particles[#particles]
        particles[#particles] = nil
      end
    end

    if nextp < time then
      if vx > 0 then
        particles[#particles+1] = {x, y, -600, math.random() * 300 - 150}
      end
      local td = 0
      if vx > 0 then
        td = 0.1 / vx
      end
      nextp = time + td
    end
  end

end


function love.draw()
  love.graphics.clear()

  if not gameover then

    love.graphics.push()
    love.graphics.translate(x, y)
    love.graphics.polygon('fill', 0, -10, 30, 0, 5, 0)
    love.graphics.polygon('fill', 0, 10, 30, 0, 5, 0)
    love.graphics.pop()

    for i, b in ipairs(bullets) do
      love.graphics.push()
      love.graphics.translate(b[1], b[2])
      love.graphics.polygon('fill', 0, 0, 100, 2, 110, 0, 100, -2)
      love.graphics.pop()
    end

    for i, e in ipairs(enemies) do
      love.graphics.push()
      love.graphics.translate(e[1], e[2])
      love.graphics.rotate(e[3])
      love.graphics.circle('line', 0, 0, e[6], e[7])
      love.graphics.pop()
    end

    for i, p in ipairs(particles) do 
      love.graphics.points(p[1], p[2])
    end

    love.graphics.print("Score: " .. tostring(math.floor(score)), 5, 5)
  else
    love.graphics.printf("G A M E   O V E R\nScore: " .. tostring(math.floor(score)), 5, 300, 800, "center")
  end
end

function love.load()
  love.graphics.setFont(love.graphics.newFont(20))
  love.window.setTitle("STALLABLASTER")
end
